<?php
//http://stackoverflow.com/questions/18382740/cors-not-working-php
if (isset($_SERVER['HTTP_ORIGIN'])) {
    header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
    header('Access-Control-Allow-Credentials: true');
    header('Access-Control-Max-Age: 86400');    // cache for 1 day
}

// Access-Control headers are received during OPTIONS requests
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
        header("Access-Control-Allow-Methods: GET, POST, OPTIONS");

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
        header("Access-Control-Allow-Headers:        
            {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

    exit(0);
}

$postdata = file_get_contents("php://input");
$request = json_decode($postdata);

@$idagentehash = $request->idagentehash;

$ret['request']=$request;
$ret['postdata']=$postdata;

if($idagentehash!='') {
    include("db_connect.php");

    $stmt=$dbh->prepare("SELECT id_agente FROM tb_agenti WHERE (idagentehash = ?) LIMIT 1");
    $stmt->execute(array($idagentehash));

    if ($agente=$stmt->fetch(PDO::FETCH_ASSOC)) {
        //ora controllo che tutti i campi obbligatori siano stati inseriti
        $errore='';

        @$contrattonuovo_idcliente=$request->contrattonuovo_idcliente;
        @$contratto_idcluster=$request->contratto_idcluster;
        @$nuovocontratto=$request->nuovocontratto;


        if ((isset($contrattonuovo_idcliente)) && $contrattonuovo_idcliente>0) {
        } else {
            $ret['result']=false;
            $ret['error']="Manca l'id del cliente nuovo non possiamo salvare!";
            echo json_encode($ret);
            exit;
        }

        if ((isset($contratto_idcluster)) && $contratto_idcluster>0) {
        } else {
            $ret['result']=false;
            $ret['error']="Manca il category del contratto non possiamo salvare!";
            echo json_encode($ret);
            exit;
        }

        //ci sono 2 tipi di gruppi di campi
        //se il cliente è nel cluster grandi clienti, c'è solo la prima parte (allestimento)
        //inoltre se il cliente è un vecchio cliente, allora tipologia_planogramma e metri lineari non sono richiesti

        //grandi clienti vecchio contratto
        if (($contratto_idcluster!=1) && ($nuovocontratto==0)) {
            //non serve niente, siamo a posto così
        }

        //grandi clienti nuovo contratto
        if (($contratto_idcluster!=1) && ($nuovocontratto==1)) {

            //intanto guardo se ho category_2017
            if ($request->category_2017==1) {
                //controllo tipologia_planogramma e metri_lineari_merchandise
                if ((isset($request->tipologia_planogramma)) && $request->tipologia_planogramma!='Nessuno') {
                } else {
                    $ret['result']=false;
                    $ret['error']="Selezionare la tipologia di planogramma!";
                    echo json_encode($ret);
                    exit;
                }
                if ((isset($request->cm_a_parete)) && $request->cm_a_parete>0) {
                } else {
                    $ret['result']=false;
                    $ret['error']="Selezionare spazio lineare per il merchandise (in cm)!";
                    echo json_encode($ret);
                    exit;
                }
                //qui siamo a posto
            } else if ($request->merchandising_base==1) {
                //qui siamo a posto
            } else {
                $ret['result']=false;
                $ret['error']="Selezionare category oppure merchandising base!";
                echo json_encode($ret);
                exit;
            }
        }


        if ($contratto_idcluster==1) {
            if ($nuovocontratto==1) {
                //intanto guardo se ho category_2017
                if ($request->category_2017==1) {
                    //controllo tipologia_planogramma e metri_lineari_merchandise
                    if ((isset($request->tipologia_planogramma)) && $request->tipologia_planogramma!='Nessuno') {
                    } else {
                        $ret['result']=false;
                        $ret['error']="Selezionare la tipologia di planogramma!";
                        echo json_encode($ret);
                        exit;
                    }
                    if ((isset($request->cm_a_parete)) && $request->cm_a_parete>0) {
                    } else {
                        $ret['result']=false;
                        $ret['error']="Selezionare spazio lineare per il merchandise (in cm)!";
                        echo json_encode($ret);
                        exit;
                    }
                    //qui siamo a posto
                } else if ($request->merchandising_base==1) {
                    //qui siamo a posto
                } else {
                    $ret['result']=false;
                    $ret['error']="Selezionare category oppure merchandising base!";
                    echo json_encode($ret);
                    exit;
                }
            } else {
                //ci deve essere conferma_category oppure merchandising_base
                if ($request->conferma_category==1 || $request->merchandising_base==1) {
                    //siamo a posto
                } else {
                    $ret['result']=false;
                    $ret['error']="Selezionare conferma category oppure merchandising base!";
                    echo json_encode($ret);
                    exit;
                }
            }
            //ora possiamo proseguire per entrambi (contratto vecchio oppure nuovo)
            //campagna vetrine
            if (isset($request->campagnavetrine)) {
                if ($request->campagnavetrine=='Aderisco' || $request->campagnavetrine=='Non Aderisco') {

                } else {
                    $ret['result']=false;
                    $ret['error']="Selezionare adesione a campagna vetrine!";
                    echo json_encode($ret);
                    exit;
                }
            }
            //Formazione
            if (
                (isset($request->formazione)) && ($request->formazione=='1')
            ) {
            } else {
                $ret['result']=false;
                $ret['error']="Selezionare la formazione!";
                echo json_encode($ret);
                exit;
            }

        }

        //se sono arrivato fino a qui vuol dire che non ci sono errori nel form e tutti i campi obbligaori sono arrivati
        $query="INSERT INTO tb_contratti SET ";

        $set=array();
        $value=array();
        $now=date("Y-m-d H:i:s");

        $set[]="id_agente=".$agente['id_agente'];

        $set[]="id_cliente=".$request->contrattonuovo_idcliente;

        $set[]="data_contratto='".$now."'";

        $set[]="conferma_category=".$request->conferma_category;

        $set[]="category_2017=".$request->category_2017;

        $set[]="merchandising_base=".$request->merchandising_base;


        $set[]="cm_a_parete='".$request->cm_a_parete."'";

        $set[]="tipologia_planogramma='".$request->tipologia_planogramma."'";

        if ($request->campagnavetrine=='Aderisco') {
            $set[]="campagne_vetrina=1";
        } else {
            $set[]="campagne_vetrina=0";
        }

        if ((isset($request->formazione)) && ($request->formazione=='1')) {
            $set[]="formazione=1";
        } else {
            $set[]="formazione=0";
        }


        if ((isset($request->locandina)) && ($request->locandina=='1')) {
            $set[]="locandina=1";
        } else {
            $set[]="locandina=0";
        }

        if ((isset($request->inviti)) && ($request->inviti=='1')) {
            $set[]="inviti=1";
        } else {
            $set[]="inviti=0";
        }

        if ((isset($request->facebook)) && ($request->facebook=='1')) {
            $set[]="facebook=1";
            $set[]="ha_facebook=".$request->ha_facebook;
            $set[]="non_ha_facebook=".$request->non_ha_facebook;
            if ($request->ha_facebook==1) {
                $set[]="indirizzo_facebook='".$request->indirizzo_facebook."'";
            }
        } else {
            $set[]="facebook=0";
            $set[]="ha_facebook=0";
            $set[]="non_ha_facebook=0";
            $set[]="indirizzo_facebook=NULL";
        }

        if ((isset($request->campioni)) && ($request->campioni=='1')) {
            $set[]="campioni=1";
        } else {
            $set[]="campioni=0";
        }

        if ((isset($request->newsletter)) && ($request->newsletter=='1')) {
            $set[]="newsletter=1";
        } else {
            $set[]="newsletter=0";
        }

        if ((isset($request->sconti)) && ($request->sconti=='20')) {
            $set[]="sconto_10=0";
            $set[]="sconto_20=1";
        } else if ((isset($request->sconti)) && ($request->sconti=='10')) {
            $set[]="sconto_10=1";
            $set[]="sconto_20=0";
        } else {
            $set[]="sconto_10=0";
            $set[]="sconto_20=0";
        }

        if ((isset($request->impegni_assortimento)) && ($request->impegni_assortimento=='1')) {
            $set[]="impegni_assortimento=1";
        } else {
            $set[]="impegni_assortimento=0";
        }
        if ((isset($request->impegni_merchandising)) && ($request->impegni_merchandising=='1')) {
            $set[]="impegni_merchandising=1";
        } else {
            $set[]="impegni_merchandising=0";
        }
        if ((isset($request->impegni_eventi_mamma)) && ($request->impegni_eventi_mamma=='1')) {
            $set[]="impegni_eventi_mamma=1";
        } else {
            $set[]="impegni_eventi_mamma=0";
        }

        $queryset=join(",",$set);

        $dbh->beginTransaction();

        $now=date("Y-m-d H:i:s");
        $url="contratto.php";
        $descrizione=json_encode($request)."----".$query.$queryset;
        $querynot="INSERT INTO notifiche (url,descrizione,data) VALUES (?,?,?)";
        $stmtnot=$dbh->prepare($querynot);
        $stmtnot->execute(array($url,$descrizione,$now));

        if ($stmt=$dbh->query($query.$queryset)) {

            //poi devo aggiornare la tabella clienti
            // e mettere l'id_contratto anche nella tabella dei clienti
           $lastId = $dbh->lastInsertId();

/*
            $query2="UPDATE tb_clienti SET id_contratto=$lastId WHERE id_cliente=".$_POST['contrattonuovo_idcliente'];
            $stmt2=$dbh->query($query2);
*/
            $dbh->commit();

            $ret['result']=true;
            $ret['id_contratto']=$lastId;
            echo json_encode($ret);
            exit;

        } else {
            $dbh->rollBack();
            $ret['result']=false;
            $ret['queryset']=$queryset;
            $ret['error']='Errore creazione contratto!';
            echo json_encode($ret);
            exit;
        }
    } else {
        $ret['result']=false;
        $ret['error']='Id Agente errato!';
        echo json_encode($ret);
        exit;
    }


} else {
    $ret['result']=false;
    $ret['error']='Parametri non inseriti!';
    echo json_encode($ret);
    exit;
}

?>